<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Rednerliste</title>
</head>
<body>
    <h1>Rednerliste</h1>
    <label>Neuer Redner:</label>
    <input type="text">
    <button>Hinzufügen</button>
    <ul></ul>

    <script>
        const input = document.querySelector('input');
        const button = document.querySelector('button');
        const list = document.querySelector('ul');

        button.onclick = function()
        {
            const start = function()
            {
                const allbuttons = list.getElementsByTagName('button');
                for(i = 0; i < allbuttons.length; i++)
                {
                    var element = allbuttons[i];
                    element.onclick = stop;
                    element.click();
                }
                this.innerHTML = "Stop!";
                this.onclick = stop;
                this.counter.run();
            }
            const stop = function()
            {
                this.innerHTML = "Start!";
                this.onclick = start;
                this.counter.stop();
            }
            
            const value = input.value;
            const listItem = document.createElement('li');
            list.appendChild(listItem);
            listItem.innerHTML = `${value} <span>00:00:00</span> <button></button>`;
            
            const counter = function()
            {
                var acitve;
                var timesecs = 0;
                var timehours = 0;
                var timemins = 0;
                setInterval(function()
                {
                    if(acitve === true)
                        ++timesecs;

                    if (timesecs === 60)
                    {
                        timesecs = 0;
                        ++timemins;
                    }
                    if(timemins === 60)
                    {
                        timemins = 0;
                        ++timehours;
                    }

                    var timehourstring = ""+timehours;
                    if(timehours < 10)
                        timehourstring = "0" + timehours;

                    var timeminsstring = ""+timemins;
                    if(timemins < 10)
                        timeminsstring = "0" + timemins;

                    var timesecstring = ""+ timesecs;
                    if(timesecs < 10)
                        timesecstring = "0" + timesecs;

                    listItem.querySelector('span').innerHTML = `${timehourstring}:${timeminsstring}:${timesecstring}`;

                }, 1000);
                return {
                    run : function()
                    {
                        acitve = true;
                    },
                    stop : function()
                    {
                        acitve = false;
                    }
                }
            }
            
            const timeButton = listItem.querySelector('button');
            timeButton.counter = counter();
            timeButton.onclick = start;
            timeButton.click();
            input.value = "";
        }
    
        input.onkeydown = (event) =>
        {
            if (event.key === 'Enter')
                button.click();
        }
        document.onclick = () => input.focus();

    </script>
</body>
</html>